{% extends 'base.html.twig' %}

{% block body -%}
<main class='main-content bgc-grey-100'>
  <div id='mainContent'>
    <h1 xmlns="http://www.w3.org/1999/html">Sincronizzazione Manuale Dati Provider {{ provider.name }}</h1>

    <div id="syncComp">
        <!-- Nav tabs -->
        <ul class="nav nav-tabs" role="tablist">
            <li class="nav-item" role="presentation" v-for="tab in tabs"><a @click.prevent="currentTab = tab.id" role="tab" class="nav-link" :class="{active: currentTab == tab.id}" href="#">${ tab.name }</a></li>
        </ul>

        <!-- Tab panes -->
        <div class="tab-content">
            <div role="tabpanel" class="tab-pane active" v-if="currentTab == tab.id" v-for="tab in tabs">
                <h3>${ tab.name }</h3>

                <template v-if="data[tab.id] !== undefined">
                    <div class="card" style="margin-bottom: 1rem">
                        <div class="card-header">Dati da Importare</div>

                        <div class="card-body">
                            <template v-if="data[tab.id].toImport !== undefined && Object.keys(data[tab.id].toImport).length > 0">
                                <synccomp-table :entities="data[tab.id].toImport" :entity-type="tab.id" action-type="import" :tab-options="tab.options" @executeaction="executeAction"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da importare
                            </div>
                        </div>
                    </div>

                    <div class="card" style="margin-bottom: 1rem">
                        <div class="card-header">Dati da Aggiornare</div>

                        <div class="card-body">
                            <template v-if="data[tab.id].toUpdate !== undefined && Object.keys(data[tab.id].toUpdate).length > 0">
                                <synccomp-table :entities="data[tab.id].toUpdate" :entity-type="tab.id" action-type="update" :tab-options="tab.options" @executeaction="executeAction"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da aggiornare
                            </div>
                        </div>
                    </div>

                    <div class="card">
                        <div class="card-header">Dati da Eliminare</div>

                        <div class="card-body">
                            <template v-if="data[tab.id].toDelete !== undefined && Object.keys(data[tab.id].toDelete).length > 0">
                                <synccomp-table :entities="data[tab.id].toDelete" :entity-type="tab.id" action-type="delete" :tab-options="tab.options" @executeaction="executeAction"></synccomp-table>
                            </template>
                            <div v-else>
                                Non ci sono dati da cancellare
                            </div>
                        </div>
                    </div>
                </template>
                <div v-else>
                    Non ci sono dati da visualizzare
                </div>
            </div>
        </div>

        <br /><br />

        <button class="btn" @click="loadData" :class="{'btn-primary': !loading, 'btn-warning': loading}" :disabled="loading"><span v-if="loading">Caricamento</span><span v-else>Ricarica</span> dati dal provider</button>
        <a href="{{ path('config_edit') }}" class="btn btn-secondary">Ritorna alla configurazione</a>
    </div>
</div>
</main>
    <script type="text/x-template" id="syncComp-table">
        <div>
            <form class="form-inline" v-if="actionType == 'delete' && (entityType == 'students' || entityType == 'teachers' || entityType == 'groups')">
                <div class="form-check form-check-inline" v-if="entityType == 'students' || entityType == 'teachers' || entityType == 'groups'">
                    <input type="checkbox" class=“form-check-input” :id="'syncComp-deleteLdap'+entityType" v-model="tabOptions.deleteOnLdap">
                    <label class="form-check-label" :for="'syncComp-deleteLdap'+entityType">Elimina da Ldap</label>
                </div>
                <div class="form-check form-check-inline" v-if="entityType == 'groups'">
                    <input type="checkbox" class=“form-check-input” :id="'syncComp-deleteGapps'+entityType" v-model="tabOptions.deleteOnGApps">
                    <label class="form-check-label" :for="'syncComp-deleteGapps'+entityType">Elimina da Google Apps</label>
                </div>
                <div class="form-group" v-if="entityType == 'students' || entityType == 'teachers'">
                    <label :for="'deleteOnGApps'+entityType">Elimina su Google Apps</label>
                    <select class="form-control" :id="'deleteOnGApps'+entityType" v-model="tabOptions.deleteOnGApps">
                        <option value="0">No</option>
                        <option value="1">Si</option>
                        <option value="2">Sposta in OU</option>
                    </select>
                </div>
                <div class="form-group" v-if="(entityType == 'students' || entityType == 'teachers') && tabOptions.deleteOnGApps == 2">
                    <label :for="'gAppsOu'+entityType">OU</label>
                    <input type="text" class="form-control" :id="'gAppsOu'+entityType" v-model="tabOptions.gAppsOu">
                </div>
                <hr />
            </form>

            <div class="table-responsive">
                <table class="table table-striped">
                    <tr>
                        <th><input type="checkbox" :checked="allChecked" @click.prevent="toggleAllCheckbox"></th>
                        <th>Nome</th>
                        <th>Stato</th>
                        <th>Azione</th>
                    </tr>
                    <synccomp-tr
                            v-for="(entity, id) in entities"
                            :entity="entity"
                            :entity-type="entityType"
                            :action-type="actionType"
                            :key="id"
                            :id="id"
                            :checked="checked.indexOf(id) > -1"
                            @executeaction="$emit('executeaction', $event)"
                            @checkboxclicked="checkboxClicked"
                    ></synccomp-tr>
                </table>
            </div>
            <button class="btn btn-primary" :disabled="checked.length < 1" @click="executeSelected">Esegui Selezionati</button>
        </div>
    </script>

    <script type="text/x-template" id="syncComp-tr">
        <tr>
            <td><input type="checkbox" :checked="checked" @click.prevent="$emit('checkboxclicked', id)" :disabled="disabled" /></td>
            <td>${ entity.data._name }</td>
            <td>${ stateMsg }</td>
            <td><button @click="executeAction(id, entityType, actionType)" class="btn btn-primary" :disabled="disabled">Esegui</button></td>
        </tr>
    </script>

{% endblock %}

{% block javascripts -%}
    {{ parent() }}
    <script type="text/javascript" src="https://unpkg.com/vue@2.5"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue-resource@1.3.4"></script>
{#<script type="text/javascript" src="https://unpkg.com/vue@2.4.2"></script>#}
{#    <script src="https://cdn.jsdelivr.net/npm/vue-resource@1.3.4"></script>#}

    <script type="text/javascript">
        window.addEventListener('load', () => {
            var syncCompTr = {
                template: '#syncComp-tr',
                delimiters: ['${', '}'],
                props: ['entity', 'entityType', 'checked', 'id', 'actionType'],
                computed: {
                    stateMsg: function () {
                        if (this.entity.error !== null) {
                            return "Errore: " + this.entity.error;
                        }

                        if (this.entityType === "students" && this.entity.data.internalGroupId === null) {
                            return "Disabilitato per classe non importata";
                        }

                        if (this.entityType === "groups" && this.entity.data.internalSectorId === null) {
                            return "Disabilitato per settore non importato";
                        }

                        switch (this.entity.state) {
                            case 1:
                                return "In Coda";

                            case 2:
                                return "Elaborazione";

                            case 3:
                                return "Completato";

                            default:
                                return "Da Iniziare";
                        }
                    },
                    disabled: function () {
                        if (this.entity.state > 0) {
                            return true;
                        }

                        if (this.entityType === "students" && this.entity.data.internalGroupId === null) {
                            return true;
                        }

                        if (this.entityType === "groups" && this.entity.data.internalSectorId === null) {
                            return true;
                        }

                        return false;
                    }
                },
                methods: {
                    executeAction: function (entityId, entityType, actionType) {
                        this.$emit('executeaction', {
                            'entityId': entityId,
                            'entityType': entityType,
                            'actionType': actionType
                        });
                        if (this.checked) {
                            this.$emit('checkboxclicked', entityId);
                        }
                    }
                }
            };

            var syncCompTable = {
                template: '#syncComp-table',
                delimiters: ['${', '}'],
                props: ['entities', 'entityType', 'entityType', 'actionType', 'tabOptions'],
                data: function () {
                    return {
                        checked: [],
                        allChecked: false
                    }
                },
                methods: {
                    checkboxClicked: function (id) {
                        var pos = this.checked.indexOf(id);
                        if (pos > -1) {
                            this.checked.splice(pos, 1);
                        } else {
                            this.checked.push(id);
                        }
                    },
                    toggleAllCheckbox: function () {
                        this.checked = [];
                        if (!this.allChecked) {
                            for (var i in this.$children) {
                                if (!this.$children[i].disabled) {
                                    this.checked.push(this.$children[i].id);
                                }
                            }
//                        this.checked = Object.keys(this.entities);
                        }
                        this.allChecked = !this.allChecked;
                    },
                    executeSelected: function () {
                        for (var entityIdIdx in this.checked) {
                            this.$emit('executeaction', {
                                'entityId': this.checked[entityIdIdx],
                                'entityType': this.entityType,
                                'actionType': this.actionType
                            });
                        }

                        this.checked = [];
                    }
                },
                components: {
                    'synccomp-tr': syncCompTr
                }
            };

            var syncComp = new Vue({
                el: "#syncComp",
                delimiters: ['${', '}'],
                data: {
                    loading: false,
                    data: {},
                    tabs: [
                        {id: "sectors", name: "Settori", options: {}},
                        {id: "groups", name: "Classi", options: {deleteOnLdap: false, deleteOnGApps: 0}},
                        {id: "students", name: "Studenti", options: {deleteOnLdap: false, deleteOnGApps: 0, gAppsOu: '/'}},
                        {id: "teachers", name: "Docenti", options: {deleteOnLdap: false, deleteOnGApps: 0, gAppsOu: '/'}},
                        {id: "subjects", name: "Materie", options: {}}
                    ],
                    executionQueue: [],
                    queueWorking: false,
                    currentTab: 'sectors'
                },
                methods: {
                    loadData: function () {
                        this.loading = true;
//                    this.$http.get('http://igroove.sviluppo.salesianisesto.it/load-data3.json').then(
                        this.$http.post('{{ path('config_provider_load_data', {'id' :  provider.id}) }}').then(
                            function (response) {
                                return response.json()
                            }
                        ).then(function (ajaxData) {
                            if (typeof ajaxData !== "object" || ajaxData.data === undefined) {
                                alert(ajaxData.error !== undefined ? ajaxData.error : "Impossibile caricare i dati dal server");
                                this.loading = false;
                                return;
                            }

                            var actionTypes = ['toImport', 'toUpdate', 'toDelete'];
                            var newData = {};
                            var actionType;
                            var tabId;
                            for (var tabIdx in this.tabs) {
                                tabId = this.tabs[tabIdx].id;
                                newData[tabId] = {};
                                for (var dataTypeIdx in actionTypes) {
                                    actionType = actionTypes[dataTypeIdx];
                                    newData[tabId][actionType] = {};

                                    if (ajaxData.data[tabId] === undefined || ajaxData.data[tabId][actionType] === undefined) {
                                        continue;
                                    }

                                    for (var entityId in ajaxData.data[tabId][actionType]) {
                                        newData[tabId][actionType][entityId] = {
                                            data: ajaxData.data[tabId][actionType][entityId],
                                            state: 0,
                                            error: null
                                        }
                                    }
                                }
                            }

                            this.data = newData;
                            this.loading = false;
                        }).catch(function () {
                            this.loading = false;
                            alert("Impossibile caricare i dati dal server");
                        });
                    },
                    callAction: function (payload) {
                        if (typeof payload !== 'object' ||
                            payload.action === undefined ||
                            payload.entityId === undefined ||
                            payload.entityType === undefined ||
                            payload.entity === undefined ||
                            payload.options === undefined
                        ) {
                            return;
                        }

                        payload.entity.state = 2;

                        var url = "";
                        switch (payload.action) {
                            case "import":
                                url = '{{ path('config_provider_import_data', {'providerId' :  provider.id}) }}';
                                break;

                            case "update":
                                url = '{{ path('config_provider_update_data', {'providerId' :  provider.id}) }}';
                                break;

                            case "delete":
                                url = '{{ path('config_provider_remove_data', {'providerId' :  provider.id}) }}';
                                break;
                        }

                        if (url === "") {
                            return;
                        }

                        var $this = this;
                        this.$http.post(url, {
                            entityData: payload.entity.data,
                            entityId: payload.entityId,
                            entityType: payload.entityType,
                            options: payload.options
                        }).then(function (response) {
                            return response.json()
                        }).then(function (ajaxData) {
                            if (typeof ajaxData !== "object" || ajaxData.success !== true) {
                                throw typeof ajaxData === 'object' && ajaxData.error !== undefined ? ajaxData.error : null;
                            }

                            payload.entity.state = 3;
                            if (ajaxData.newEntityId !== undefined) {
                                var entityIdx;
                                if (payload.entityType === "sectors") {
                                    for (entityIdx in $this.data.groups.toImport) {
                                        if ($this.data.groups.toImport[entityIdx].sectorId == payload.entityId) {
                                            $this.data.groups.toImport[entityIdx].internalSectorId = ajaxData.newEntityId;
                                        }
                                    }

                                    for (entityIdx in $this.data.groups.toUpdate) {
                                        if ($this.data.groups.toUpdate[entityIdx].sectorId == payload.entityId) {
                                            $this.data.groups.toUpdate[entityIdx].internalSectorId = ajaxData.newEntityId;
                                        }
                                    }
                                } else if (payload.entityType === "groups") {
                                    for (entityIdx in $this.data.student.toImport) {
                                        if ($this.data.student.toImport[entityIdx].groupId == payload.entityId) {
                                            $this.data.student.toImport[entityIdx].internalGroupId = ajaxData.newEntityId;
                                        }
                                    }

                                    for (entityIdx in $this.data.student.toUpdate) {
                                        if ($this.data.student.toUpdate[entityIdx].groupId == payload.entityId) {
                                            $this.data.student.toUpdate[entityIdx].internalGroupId = ajaxData.newEntityId;
                                        }
                                    }
                                }
                            }

                            $this.queueWorking = false;
                            $this.tickQueue();
                        }).catch(function (err) {
                            this.loading = false;
                            payload.entity.error = typeof err === "string" ? err : "Impossibile elaborare la richiesta";
                            payload.entity.state = 0;
                            $this.queueWorking = false;
                            $this.tickQueue();
                        });
                    },
                    executeAction: function (payload) {
                        if (typeof payload !== 'object' || payload.actionType === undefined || payload.entityId === undefined || payload.entityType === undefined) {
                            return;
                        }

                        var actionType = "to" + payload.actionType.substr(0, 1).toUpperCase() + payload.actionType.substr(1);

                        if (this.data[payload.entityType] === undefined ||
                            this.data[payload.entityType][actionType] === undefined ||
                            this.data[payload.entityType][actionType][payload.entityId] === undefined
                        ) {
                            return;
                        }

                        if (this.data[payload.entityType][actionType][payload.entityId].state > 0) {
                            return;
                        }

                        this.data[payload.entityType][actionType][payload.entityId].state = 1;
                        this.data[payload.entityType][actionType][payload.entityId].error = null;

                        this.executionQueue.push({
                            action: payload.actionType,
                            entityId: payload.entityId,
                            entityType: payload.entityType,
                            entity: this.data[payload.entityType][actionType][payload.entityId],
                            options: (this.tabs.find(function (el) {
                                return el.id == payload.entityType
                            }) || {options: {}}).options
                        });
                        this.tickQueue();
                    },
                    tickQueue: function () {
                        if (this.queueWorking || this.executionQueue.length < 1) {
                            return;
                        }

                        var $this = this;
                        $this.queueWorking = true;

                        setTimeout(function () {
                            $this.callAction($this.executionQueue.shift());
                        }, 0);
                    }
                },
                components: {
                    'synccomp-table': syncCompTable
                },
                mounted: function () {
                    var $this = this;
                    setTimeout(function () {
                        $this.loadData();
                    }, 500);
                },
                http: {
                    emulateJSON: true,
                    emulateHTTP: true
                }
            });
        });
    </script>

{% endblock %}